/*
 *  FONT.H   Headerfile for FONT.C
 *
 *  stroked fonts:	      (c) 1988 - 1993 Borland International
 *  BGIFONT package:	      (c) 1988 - 1989 Borland International
 *  'package derived from the BGIFONT package from Borland International'
 *  SVGAKIT, VESA extensions: (c) 1993 Johannes Martin
 *  EMX/GCC:		      (c) 1992 - 1993 Eberhard Mattes
 *  functions not covered by the above listed copyrights:
 *			      (c) 1993 Matthias Burian
 *
 *  $Author: M_Burian $
 *  $Date: 1993/08/04 19:54:25 $
 *  $Source: c:/work/bc/chr/RCS/font.h%v $
 *  $Revision: 0.1 $
 */

/*
 * The usual prototypes ...
 */
void g_set_font_dimensions(int height, int width);
void g_get_font_dimensions(int *width, int *height);
void g_set_text_direction(int direction);
int  g_get_text_direction(void);
int  g_get_current_font(void);
int  g_use_font(unsigned int font);
int  g_get_string_width(char *str);
void g_draw_string(int x, int y, char *str, int color);

/*
 *  The possible directions of text writing
 */
#define		UP		1
#define		DOWN		2
#define		RIGHT		3
#define		NORMAL		3

/*
 *  The default values for x- and y-stretching
 */
#define		DEFAULT_WIDTH	-1
#define		DEFAULT_HEIGHT	-1

/*
 *  These are the font names for being loaded
 */
#define		TRIPLEX		   1
#define		SANSSER		   2
#define		BOLDFON		   3
#define		EUROFON		   4
#define		GOTHICF		   5
#define		SCRIPTF		   6
#define		LCOMFON		   7
#define		LITTLEF		   8
#define		TSCRFON		   9
#define		SIMPLEX		  10

#define		NO_FONT		  -1

/*
 *  end FONT.H
 */
