/* gget.c (emx+gcc) -- Copyright (c) 1987-1993 by Johannes Martin */

#include <sys/hw.h>
#include <vesa.h>

#include "vgaports.h"
#include "graph.h"
#include "graph2.h"
#include "graph3.h"

int FLAT256_get(int x, int y)
{
  return(_g_rmem[y * _g_linesize + x]);
}

int FLAT32k_get(int x, int y)
{
  return(*(short *) (_g_rmem + y * _g_linesize + x * 2));
}

int FLAT16m_get(int x, int y)
{
  int offset = y * _g_linesize + x * 3;

  return(RGB24(_g_rmem[offset], _g_rmem[offset + 1], _g_rmem[offset + 2]));
}

int SEG256_get(int x, int y)
{
  int offset, win;

  offset = y * _g_linesize + x;
  win    = offset / _g_wingran;

  GSETRWIN(win);

  return(_g_rmem[offset & (_g_wingran - 1)]);
}

int SEG32k_get(int x, int y)
{
  int offset, win;

  offset = y * _g_linesize + x * 2;
  win    = offset / _g_wingran;

  GSETRWIN(win);

  return(*(short *) (_g_rmem + (offset & (_g_wingran - 1))));
}

int SEG16m_get(int x, int y)
{
  int offset, win;

  offset = y * _g_linesize + x * 3;
  win    = offset / _g_wingran;

  GSETRWIN(win);

  offset &= _g_wingran - 1;

  return(RGB24(_g_rmem[offset], _g_rmem[offset + 1], _g_rmem[offset + 2]));
}

int ALT256_get(int x, int y)
{
  _outp8(GRA_I, 0x04);
  _outp8(GRA_D, x & 3);

  return(_g_rmem[ y * _g_linesize + (x >> 2)]);
}

int g_get(int x, int y)
{
  int color;

  if ((x < _g_clipx0) || (x > _g_clipx1) || (y < _g_clipy0) || (y > _g_clipy1))
    return(-1);
  GLOCK;
  color = _g_get(x, y);
  GUNLOCKNM;
  return(color);
}
