#define INCL_DOSMODULEMGR
#define INCL_DOSMISC

#include <os2.h>
#include <stdlib.h>

#include "vesa.h"
#include "vesa_dos.h"

static HMODULE hmod;

static VESABOOL dummy(void)
{
  return(TRUE);
}

static void MyExit(void)
{
  DosFreeModule(hmod);
}

VESABOOL VesaInitialize(void)
{
  if (_osmode == OS2_MODE)
    {
      CHAR Error[100];
      PCSZ EnvVar;

      if (DosScanEnv("VESADLL", &EnvVar))
        EnvVar = "VESA_PM";
      if (DosLoadModule(Error, sizeof(Error), EnvVar, &hmod))
        return(FALSE);
      atexit(MyExit);
      if ((DosQueryProcAddr(hmod,  1, NULL, (PFN*) &VesaGetInfo)) ||
          (DosQueryProcAddr(hmod,  2, NULL, (PFN*) &VesaGetModeInfo)) ||
          (DosQueryProcAddr(hmod,  3, NULL, (PFN*) &VesaSetMode)) ||
          (DosQueryProcAddr(hmod,  4, NULL, (PFN*) &VesaGetMode)) ||
          (DosQueryProcAddr(hmod,  5, NULL, (PFN*) &VesaSetWindow)) ||
          (DosQueryProcAddr(hmod,  6, NULL, (PFN*) &VesaGetWindow)) ||
          (DosQueryProcAddr(hmod,  7, NULL, (PFN*) &VesaSetScanlineLength)) ||
          (DosQueryProcAddr(hmod,  8, NULL, (PFN*) &VesaGetScanlineLength)) ||
          (DosQueryProcAddr(hmod,  9, NULL, (PFN*) &VesaSetSwitchFunc)) ||
          (DosQueryProcAddr(hmod, 10, NULL, (PFN*) &VesaLockScreen)) ||
          (DosQueryProcAddr(hmod, 11, NULL, (PFN*) &VesaUnlockScreen)) ||
          (DosQueryProcAddr(hmod, 12, NULL, (PFN*) &VesaSetModified)) ||
          (DosQueryProcAddr(hmod, 13, NULL, (PFN*) &VesaSetPalette)) ||
          (DosQueryProcAddr(hmod, 14, NULL, (PFN*) &VesaGetPalette)) ||
          (DosQueryProcAddr(hmod, 15, NULL, (PFN*) &VesaGetCharacter)) ||
          (DosQueryProcAddr(hmod, 16, NULL, (PFN*) &VesaKeyboardHit)))
        return(FALSE);
      else
        return(TRUE);
    }
  else
    {
      VESAINFO VesaInfo;

      if (DosVesaGetInfo(&VesaInfo))
        {
          VesaGetInfo           = DosVesaGetInfo;
          VesaGetModeInfo       = DosVesaGetModeInfo;
          VesaSetMode           = DosVesaSetMode;
          VesaGetMode           = DosVesaGetMode;
          VesaSetWindow         = DosVesaSetWindow;
          VesaGetWindow         = DosVesaGetWindow;
          VesaSetScanlineLength = DosVesaSetScanlineLength;
          VesaGetScanlineLength = DosVesaGetScanlineLength;
        }
      else
        {
          VesaGetInfo           = DosNoVesaGetInfo;
          VesaGetModeInfo       = DosNoVesaGetModeInfo;
          VesaSetMode           = DosNoVesaSetMode;
          VesaGetMode           = DosNoVesaGetMode;
          VesaSetWindow         = DosNoVesaSetWindow;
          VesaGetWindow         = DosNoVesaGetWindow;
          VesaSetScanlineLength = DosNoVesaSetScanlineLength;
          VesaGetScanlineLength = DosNoVesaGetScanlineLength;
        }
      VesaSetSwitchFunc     = (void *) dummy;
      VesaLockScreen        = (void *) dummy;
      VesaUnlockScreen      = (void *) dummy;
      VesaSetModified       = (void *) dummy;
      VesaSetPalette        = DosVesaSetPalette;
      VesaGetPalette        = DosVesaGetPalette;
      VesaGetCharacter      = DosVesaGetCharacter;
      VesaKeyboardHit       = DosVesaKeyboardHit;
    }
  return(TRUE);
}

static VESABOOL _VesaGetInfo(PVESAINFO pVesaInfo)
{
  return(VesaInitialize() && VesaGetInfo(pVesaInfo));
}

static VESABOOL _VesaGetModeInfo(VESAWORD Mode, PVESAMODEINFO pVesaModeInfo)
{
  return(VesaInitialize() && VesaGetModeInfo(Mode, pVesaModeInfo));
}

static VESABOOL _VesaSetMode(VESAWORD Mode)
{
  return(VesaInitialize() && VesaSetMode(Mode));
}

static VESABOOL _VesaGetMode(PVESAWORD Mode)
{
  return(VesaInitialize() && VesaGetMode(Mode));
}

static VESABOOL _VesaSetWindow(VESACHAR Window, VESAWORD Address)
{
  return(VesaInitialize() && VesaSetWindow(Window, Address));
}

static VESABOOL _VesaGetWindow(VESACHAR Window, PVESAWORD Address)
{
  return(VesaInitialize() && VesaGetWindow(Window, Address));
}

static VESABOOL _VesaSetScanlineLength(VESAWORD NumberOfPixels)
{
  return(VesaInitialize() && VesaSetScanlineLength(NumberOfPixels));
}

static VESABOOL _VesaGetScanlineLength(PVESAWORD BytesPerScanline,
                                       PVESAWORD NumberOfPixels,
                                       PVESAWORD NumberOfScanlines)
{
  return(VesaInitialize() && VesaGetScanlineLength(BytesPerScanline,
                             NumberOfPixels, NumberOfScanlines));
}

static VESABOOL _VesaSetSwitchFunc(VESASWITCH SwitchFunc)
{
  return(VesaInitialize() && VesaSetSwitchFunc(SwitchFunc));
}

static VESABOOL _VesaLockScreen (VESACHAR wait)
{
  return(VesaInitialize() && VesaLockScreen(wait));
}

static VESABOOL _VesaUnlockScreen (void)
{
  return(VesaInitialize() && VesaUnlockScreen());
}

static VESABOOL _VesaSetModified (void)
{
  return(VesaInitialize() && VesaSetModified());
}

static VESABOOL _VesaSetPalette(VESAWORD   StartIndex,
                                VESAWORD   NumberOfEntries,
                                PCVESACHAR Palette,
                                VESABOOL   Wait)
{
  return(VesaInitialize() && VesaSetPalette(StartIndex, NumberOfEntries,
                                            Palette, Wait));
}

static VESABOOL _VesaGetPalette(VESAWORD StartIndex,
                                VESAWORD NumberOfEntries,
                                PVESACHAR Palette)
{
  return(VesaInitialize() && VesaGetPalette(StartIndex, NumberOfEntries, Palette));
}

static VESABOOL _VesaGetCharacter(PVESACHAR pchar)
{
  return(VesaInitialize() && VesaGetCharacter(pchar));
}

static VESABOOL _VesaKeyboardHit(void)
{
  return(VesaInitialize() && VesaKeyboardHit());
}

VESABOOL (*VesaGetInfo)(PVESAINFO pVesaInfo) = _VesaGetInfo;
VESABOOL (*VesaGetModeInfo)(VESAWORD Mode, PVESAMODEINFO pVesaModeInfo) = _VesaGetModeInfo;

VESABOOL (*VesaSetMode)(VESAWORD Mode)  = _VesaSetMode;
VESABOOL (*VesaGetMode)(PVESAWORD Mode) = _VesaGetMode;

VESABOOL (*VesaSetWindow)(VESACHAR Window, VESAWORD Address)  = _VesaSetWindow;
VESABOOL (*VesaGetWindow)(VESACHAR Window, PVESAWORD Address) = _VesaGetWindow;

VESABOOL (*VesaSetScanlineLength)(VESAWORD NumberOfPixels)     = _VesaSetScanlineLength;
VESABOOL (*VesaGetScanlineLength)(PVESAWORD BytesPerScanline,
                                  PVESAWORD NumberOfPixels,
                                  PVESAWORD NumberOfScanlines) = _VesaGetScanlineLength;

VESABOOL (*VesaSetSwitchFunc)(VESASWITCH SwitchFunc) = _VesaSetSwitchFunc;
VESABOOL (*VesaLockScreen)(VESACHAR wait)            = _VesaLockScreen;
VESABOOL (*VesaUnlockScreen)(void)                   = _VesaUnlockScreen;
VESABOOL (*VesaSetModified)(void)                    = _VesaSetModified;

VESABOOL (*VesaSetPalette)(VESAWORD   StartIndex,
                           VESAWORD   NumberOfEntries,
                           PCVESACHAR Palette,
                           VESABOOL   Wait)          = _VesaSetPalette;
VESABOOL (*VesaGetPalette)(VESAWORD StartIndex,
                           VESAWORD NumberOfEntries,
                           PVESACHAR Palette)        = _VesaGetPalette;

VESABOOL (*VesaGetCharacter)(PVESACHAR pchar)        = _VesaGetCharacter;
VESABOOL (*VesaKeyboardHit)(void)                    = _VesaKeyboardHit;
